%ext ck1

%version 1.31
%patchfile 0x130F8 info.tli

#TITLE
%patch $97B2 $00 $00 #Title V
%patch $97B6 $04 $00 #Title H


# lemm's rewritten draw routine frees up enough space for us
%patchfile $11F80 adt.bin
 
#UpdateFarCall to ADT_0
%patch $B7B2 $3911W
 
#UpdateFarCall to ADT_1
%patch $B7AA $395CW

#######Level Exit tiles#######
#Exit tiles (These appear during exiting)
%patch $4128 $0099W #Top left
%patch $414C $00A6W #Bottom left
%patch $4176 $009AW #Top right
%patch $41A0 $00A7W #Bottom right

#Change point item scores 
%patch $15076 $0005W #Pizza (5) 
              $0000W #Cola  (0) 
              $0000W #Soda  (0) 
              $000AW #Book  (10) 
              $000AW #Ted   (0) 
 
# Shoot with space
%patch $1251  $48 
%patch $7FA3  $48 
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DCC  $90 $90 
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
 

###POGO Stuff####

# call $E6C0 from $3B1D + 3
%patch $3B1D $E8 $ABA0W $90 $90 $90
 
# check if we've got the ammo too
%patch $E6C0 $55                        # push bp
             $8B $EC                    # mov bp, sp
             $83 $3E $9A $AA $00        # cmp ammo, 0
             $74 $0A                    # jz down_there
             $FF $0E $9A $AA            # dec ammo
             $C7 $06 $52 $82 $54 $40    # mov think_func, a_think_31
             $8B $E5                    # mov sp, bp
             $5D                        # pop bp
             $C3                        # retn

#can't take out pogo in mid air
%patch $3DB1 $EB #jump, unconditionally, over the assignment to pogo_air func

#put away pogo when top is contacted
%patch $3FB6 $3867W

#jump high when pogo is pressed
%patch $4085 $150W
%patch $3F40 $150W
#change 400W to whatever value you want, to affect the pogo height
#lower = less high

%patch $3F3C $1500W #Keen's high pogo height variable

# add 5 pogos when a pogo tile is picked up
%patch $44AB $83 $06 $AA9AW $05 $90 

#Pogo acts normally in God Mode
%patch $3F4E $EB

##########Level Exit#########

#Don't take keys on level exit
%patch $4F51 $90 $90 

################################

###############
# Death/lives #
###############

%patch $8041 $E8 $1E $CF $90

%patch $9002 $00 $00 #Start with 0 lives
%patch $0FB0 $00 $00 #No "extra keen at" score

# skip keens left 
%patch $7E99 $90 $90 $90 # skip the display_keens_left() call 
%patch $7EBC $90 $90 $90 # skip the delay() call



######Falling Block#######

#Make falling block one tile
%patch $238D $0001W #Top left tile here
%patch $23F4 $0001W #Left end of ALL middle tiles
%patch $2465 $01   #Right end of block middle
%patch $2476 $0001W #Top right tile here

#Make block tiles background
%patch $23CD $009BW #Top left
%patch $2436 $009BW #Top middle
%patch $24B6 $009BW #Top right
%patch $23EF $009BW #Bottom left
%patch $2458 $009BW #Bottom middle
%patch $24D8 $009BW #Bottom right

#Relative location of falling block to chain
%patch $23B5 $FF   #Top left
%patch $241E $FF   #Top middle
%patch $249E $FF   #Top right
%patch $23D7 $FF   #Bottom left
%patch $2440 $FF   #Bottom middle
%patch $24C0 $FF   #Bottom right

#stop replacement tiles from appearing
%patch $23AA $C3 #left replacement
%patch $2413 $C3 #middle replacement
%patch $2493 $C3 #right replacement

%patch $24E8 $01 #Number of fall cycles

%patch $24DC $00 #Make block fall l/r instead of u/d

#Don't make falling block sound:
%patch $2347 $90 $90 $90

####################################

#skip credits sequence, go straight to main menu
%patch $A265 $90 

#Keen 1 background tiles behave like Keen 3
#Change item tiles to use tiles at the end of each row ($0D) of tiles
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01

#Change keys, items, etc to use point tiles instead
%patch $4482  $E9 $74 $FF #Affect ship parts
%patch $44BA  $E9 $3C $FF #Affect raygun, pogo
%patch $4513  $E9 $E3 $FE #Affect keycards

#Change doors
%patch $28EC                  $26 $8B $07 $B6
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90


%patch $9002 $00 $00 

#Start with 0 lives

%patch $0FB0 $00 $00 

#No "extra keen at" score

#Cards, parts, pogo, ammo, and score set to 0 on death\Same for level exit, but keeps keys

%patch $8041 $E8 $1E $CF $90 

#Keen doesn't lose a life on dying 

%patch $4F58 $A1 $60 $6C $5F $5E $8B $E5 $5D $EB $1C $90 $90 $9090W  $C7 $06 
$AA9EW  $0000W  $C7 $06 $AAA0W  $0000W  $C7 $06 $AAA2W  $0000W 
$C7 $06 $AAA4W  $0000W  $C7 $06 $AA94W  $0000W  $C7 $06 $AA96W $0000W  $90 $90 $9090W  $0000W  $C7 $06 $AA9AW  $0000W  $C7 $06 
$AA9CW  $0000W  $C7 $06 $AAC8W  $0000W  $C7 $06 $AACAW  $0000W $C7 $06 $AACCW  $0000W  $C3



# Dr. Kylstein's Monolithic patch. 

# Do not separate, do not duplicate! 

# Do not modify CODE SEGMENT!
#

#DATA SEGMENT (+$13050) 
#(You can modify these values, as long length is preserved.)
#

#--brightness palette--

#default colors (for reference only!)
# 
%patch $21B50 $0 $1 $2 $2 $4 $5 $6 $7 $18 $19 $1A $1B $1C $1D $1E $1F $03

# Choose ONE of:
# makes all dark shades bright

%patch $21B50 $18 $19 $1A $1B $1C $1D $1E $1F $18 $19 $1A $1B $1C $1D $1E $1F $03

# makes all dark shades bright, and all bright shades white
#
%patch $21B50 $18 $19 $1A $1B $1C $1D $1E $1F $1F $1F $1F $1F $1F $1F $1F $1F $03 

#
#Patch in the name of the status dialog text file, you'll need to create a file with this name and put your status

#text in it or Keen will crash.

%patch $14E52  "STATUS.CK1" $00 

#
#--physical state text--

%patch  $14E5D "UMBRAL" $00

%patch  $14E64 "AETHEREAL" $00

%patch  $14E6E "NORMAL" $00

#
#--Bad end message (grabbed teddy)--

%patch $14E75 "You are now SOL.          \r\n"
    "The greebles mourn your   \r\n" 
    "loss. Do not pass go, do  \r\n"
    "not collect 200 zorkmids." $00
%patch $14E75 "You touch the sign of     \r\n"
    "the void, all goes dark.  \r\n" 
    "A voice in your mind:     \r\n"
    "You are doomed! Hahaha..." $00




#--door cost--

%patch $21B61 100L

#
#CODE SEGMENT
#
#--new pause menu--

%patch $0E53 $000DW #Width

%patch $0E57 $0018W 
#Height
# Patch in the long-integer drawing function

%patch $11B4 $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF
 $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8
 $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A
 $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks)

%patch $0E6A $B8 $00 $3D $BA $1E02W   
# Show status window (0E6A)
 
$CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA
 $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44
 $5B $4F $75 $E8 $B4 $3E $CD $21 
%patchfile $0E98 ceilick.BIN $0E98 $31C

#
#--subroutine hooks--

# modify C-T-Space
#
%patchfile $0DF9 ceilick.BIN $0DF9 $20

#wrap call to pause menu routine

%patchfile $1259 ceilick.BIN $1259 3

#patch into gravity routine

%patchfile $2C33 ceilick.BIN $2C33 5
#replace master tile behaviour table (enables new items)
%patchfile $4590 ceilick.BIN $4590 $34
#change door code that takes away keys

%patchfile $28D0 ceilick.BIN $28D0 $B

#change "done" marker code to check for having a lollipop
%patchfile $800F ceilick.BIN $800F $E

#        
# the above patches create calls into the following code:

%patchfile $56DB ceilick.BIN $56DB $135

%patchfile $0AF2 ceilick.BIN $0AF2 $15E


#Menu pointers
%patch $95ED $9570W # New Game
             $9577W # Continue Game
             $957FW # Story
             $9589W # About ID...
             $9596W # High Scores
             $95A3W # Ordering Info
             $95B5W # Previews!
             $95C2W # Restart Demo


#Menu text:
%patch $15EE6 "   New Game" $0A $00
%patch $15EF3 "   Load Game   " $0A $00
%patch $15F05 "   Story" $0A $00
%patch $15F0F "   About ID..." $0A $00
%patch $15F1F "   High Scores" $0A $00
%patch $15F2F "   Ordering Info" $0A $00
%patch $15F41 "   Previews!" $0A $00
%patch $15F4F "   Restart Demo" $0A $0A $00




%patch $9643 $90 $90 $90 #About Id
%patch $964C $90 $90 $90 #High Scores
%patch $9655 $90 $90 $90 #Ordering Info
%patch $965E $90 $90 $90 #Previews!
%patch $9667 $90 $90 $90 #Restart Demo










%end


#sprites below INGAME type #9 operate off screen 
%patch $3347 $90 $90 $90  $90 $90 $90 $EB $0B 

#Existing ice cubes continue flight even offscreen 
%patch $3340 $83 $3E $20 $82 $09 $7C $13 $83 $3E $20 $82 $0F $74 $0C $90 

#Cannon fires, even offscreen, only makes shooting sound while onscreen 
%patch $207A $28 #4A 
%patch $2084 $1E #40 
%patch $208F $13 #35 
%patch $2099 $09 #2B 

#Cube doesn't make smash sound 
%patch $229D $90 $90 $90 

#keen rides cubes 
%patch $467A $57 $56 $E8 $E9BDW $59 $59 $B8 
         $0002W  #sound on contact 
      #$EB $D  #to play sound 
       $EB $13 #to not play sound (must include one of the $EB lines) 

#Cubes don't interact with any other sprite 
%patch $213E $2045W 


#butler/tankbots push keen smoothly (meep style) 
%patch $4646 $57 $56 $E8 $EB92W $59 $59 $B8 
      $0002W  #sound on contact 
      #$EB $41 #to play sound 
       $EB $47 #to not play sound (must include one of the $EB lines)
